var boolNext = true;
//copy
function initPuzzle(puzzleId, hints_containerId, vhintsId, hhintsId, clearId, checkId, solveId, clueId, grid, clues, answers, posCol_KeyWork) {
    
    //Draw grid
    $.each(grid, function (i) {
        var row = $('<tr></tr>');
        $.each(this, function (j) {
            if (this == 0) {
                $(row).append('<td class="square empty"></td>');
            }
            else {

                var question_number = String(grid[i][j]).split(",");
                var starting_number = '';
                var question_number_span = '';

                for (var k = 0; k < question_number.length; k++) {
                    var direction = get_direction(grid, question_number[k]);
                    var startpos = get_startpos(grid, question_number[k], direction);

                    if (direction == "horizontal" && startpos[0] == i && startpos[1] == j) {
                        starting_number += question_number[k] + ",";
                    }
                    else if (direction == "vertical" && startpos[0] == j && startpos[1] == i) {
                        starting_number += question_number[k] + ",";
                    }

                }
                if (starting_number != "") {
                    question_number_span = '<span class="question_number">' + starting_number.replace(/(^,)|(,$)/g, "") + '</span>';
                }

                $(row).append('<td><div class="square letter" data-number="' + this + '" contenteditable="true"></div>' + question_number_span + '</td>');
            }
        });
        $("#" + puzzleId).append(row);
    });

    //Fill color
    var i = 0;
    $.each(posCol_KeyWork, function (index) {
        $('#' + puzzleId + ' tr:eq(' + i + ') td:eq(' + posCol_KeyWork[i] + ') div').css("backgroundColor", "#9ce084");
        ++i;
    });

    //Draw hints

    var vertical_hints = $('<div></div>');
    var horizontal_hints = $('<div></div>');
    $.each(clues, function (index) {

        var direction = get_direction(grid, index + 1);

        if (direction == "horizontal") {
            $(horizontal_hints).append('<div class="hint"><b>' + (index + 1) + '</b>. ' + clues[index] + '</hint>');
        }
        else if (direction == "vertical") {
            $(vertical_hints).append('<div class="hint"><b>' + (index + 1) + '</b>. ' + clues[index] + '</hint>');
        }
    });
    $("#" + vhintsId).append(vertical_hints);
    $("#" + hhintsId).append(horizontal_hints);

    $(".letter").keyup(function () {
        var this_text = $(this).text();
        if (this_text.length > 1) {
            $(this).text(this_text.slice(0, 1));
        }
    });

    $(".letter").click(function () {
        document.execCommand('selectAll', false, null);

        $(".letter").removeClass("active");
        $(this).addClass("active");

        $(".hint").css("color", "initial");

        var question_numbers = String($(this).data("number")).split(",");

        $.each(question_numbers, function () {
            $("#hints .hint:nth-child(" + this + ")").css("color", "red");
        });
    });

    $("#" + solveId).click(function () {
        if (!$(".letter.active").length)
            return;
        var question_numbers = String($(".letter.active").data("number")).split(",");
        $.each(question_numbers, function () {
            fillAnswer(puzzleId, answers, grid, this);
        });
    });

    $("#" + clearId).click(function () {
        if (!$(".letter.active").length)
            return;
        var question_numbers = String($(".letter.active").data("number")).split(",");
        $.each(question_numbers, function () {
            clearAnswer(puzzleId, answers, grid, this);
        });
    });

    $("#" + checkId).click(function () {
        boolNext = true;
        $("#" + puzzleId + " td div").css("color", "initial");

        var idCauHoi = $(this).attr('data-idCauHoi');

        var arr = new Array();

        for (var i = 0; i < answers.length; i++) {
            checkAnswer(puzzleId, answers, grid, i + 1);
        }
        lstCauTraLoi.AddQuestion(arr);
        var dapan_dung = "";
        for (var i = 0; i < answers.length; i++) {
            if (dapan_dung == "")
                dapan_dung += (i + 1) + " : " + answers[i] + ' - \r\n';
            else
                dapan_dung += (i + 1) + " : " + answers[i] + '\r\n';
        }

        arr.push(idCauHoi); //id
        arr.push('Trò chơi ô chữ') //cau hoi
        arr.push('OC') //type
        arr.push('');
        arr.push(dapan_dung); // ddap an dung
        arr.push(boolNext);

        //var id = "box_slider_" + (sttSlide + 1);
        //var nextQues = document.getElementById(id);
        //if( nextQues != null){
        //	nextQues.hidden = false;
        //}
        //else{
        //	var endSlide = document.getElementById('SlEnd');
        //	endSlide.hidden = false;
        //}
        //object.prop('hidden', true) ;
    });

    $("#" + clueId).click(function () {
        if (!$(".letter.active").length)
            return;
        var question_numbers = String($(".letter.active").data("number")).split(",");
        showClue(puzzleId, answers, grid, question_numbers[0], $(".letter.active").parent().index(), $(".letter.active").parent().parent().index());
    });
}

function get_direction(grid, question_number) {
    for (var i = 0; i < grid.length; i++) {		//i: truc y	- so dong
        for (var j = 0; j < grid[i].length; j++) { //j: truc x - so cot					
            if (String(grid[i][j]).indexOf(question_number) != -1) {
                //			console.log(question_number);	

                // if(grid[i+1][j] == question_number || grid[i-1][j] == question_number){				
                // return "vertical";
                // }

                // if(grid[i][j+1] == question_number || grid[i][j-1] == question_number){
                // return "horizontal";
                // }
                return "horizontal";
            }
        }
    }
}

function get_startpos(grid, question_number, direction) {
    if (direction == "horizontal") {
        for (var i = 0; i < grid.length; i++) {
            for (var j = 0; j < grid[i].length; j++) {
                if (String(grid[i][j]).indexOf(question_number) != -1) {
                    return [i, j];
                }
            }
        }
    }

    else if (direction == "vertical") {
        for (var i = 0; i < grid.length; i++) {
            for (var j = 0; j < grid[i].length; j++) {
                if (String(grid[j][i]).indexOf(question_number) != -1) {
                    return [i, j];
                }
            }
        }
    }
}

function fillAnswer(puzzleId, answers, grid, question_number) {
    $("#" + puzzleId + " td div").css("color", "initial");

    var question_answer = answers[question_number - 1];
    var direction = get_direction(grid, question_number);
    var startpos = get_startpos(grid, question_number, direction);
    var answer_letters = question_answer.split("");

    if (direction == "horizontal") {
        for (var i = 0; i < answer_letters.length; i++) {
            $("#" + puzzleId + " tr:nth-child(" + (startpos[0] + 1) + ") td:nth-child(" + (startpos[1] + 1 + i) + ") div").text(answer_letters[i]);
        }

    }
    else if (direction == "vertical") {
        for (var i = 0; i < answer_letters.length; i++) {
            $("#" + puzzleId + " tr:nth-child(" + (startpos[1] + 1 + i) + ") td:nth-child(" + (startpos[0] + 1) + ") div").text(answer_letters[i]);
        }

    }
}

function clearAnswer(puzzleId, answers, grid, question_number) {
    $("#" + puzzleId + " td div").css("color", "initial");

    var question_answer = answers[question_number - 1];
    var direction = get_direction(grid, question_number);
    var startpos = get_startpos(grid, question_number, direction);
    var answer_letters = question_answer.split("");

    if (direction == "horizontal") {
        for (var i = 0; i < answer_letters.length; i++) {
            $("#" + puzzleId + " tr:nth-child(" + (startpos[0] + 1) + ") td:nth-child(" + (startpos[1] + 1 + i) + ") div").text('');
        }

    }
    else if (direction == "vertical") {
        for (var i = 0; i < answer_letters.length; i++) {
            $("#" + puzzleId + " tr:nth-child(" + (startpos[1] + 1 + i) + ") td:nth-child(" + (startpos[0] + 1) + ") div").text('');
        }

    }
}

function checkAnswer(puzzleId, answers, grid, question_number) {
    var question_answer = answers[question_number - 1];
    var direction = get_direction(grid, question_number);
    var startpos = get_startpos(grid, question_number, direction);
    var answer_letters = question_answer.split("");

    if (direction == "horizontal") {
        for (var i = 0; i < answer_letters.length; i++) {
            if ($("#" + puzzleId + " tr:nth-child(" + (startpos[0] + 1) + ") td:nth-child(" + (startpos[1] + 1 + i) + ") div").text().toLowerCase() != question_answer[i].toLowerCase() &&
			   $("#" + puzzleId + " tr:nth-child(" + (startpos[0] + 1) + ") td:nth-child(" + (startpos[1] + 1 + i) + ") div").text() != "") {
                boolNext = false;
                $("#" + puzzleId + " tr:nth-child(" + (startpos[0] + 1) + ") td:nth-child(" + (startpos[1] + 1 + i) + ") div").css("color", "red");
            }
            if ($("#" + puzzleId + " tr:nth-child(" + (startpos[0] + 1) + ") td:nth-child(" + (startpos[1] + 1 + i) + ") div").text() == "")
                boolNext = false;
        }
    }
    else if (direction == "vertical") {
        for (var i = 0; i < answer_letters.length; i++) {
            if ($("#" + puzzleId + " tr:nth-child(" + (startpos[1] + 1 + i) + ") td:nth-child(" + (startpos[0] + 1) + ") div").text() != question_answer[i] && $("#" + puzzleId + " tr:nth-child(" + (startpos[1] + 1 + i) + ") td:nth-child(" + (startpos[0] + 1) + ") div").text() != "") {
                $("#" + puzzleId + " tr:nth-child(" + (startpos[1] + 1 + i) + ") td:nth-child(" + (startpos[0] + 1) + ") div").css("color", "red");
            }
        }
    }
}

function showClue(puzzleId, answers, grid, question_number, i, j) {
    var question_answer = answers[question_number - 1];
    var direction = get_direction(grid, question_number);
    var startpos = get_startpos(grid, question_number, direction);
    var answer_letters = question_answer.split("");

    if (direction == "horizontal") {
        $("#" + puzzleId + " tr:nth-child(" + (j + 1) + ") td:nth-child(" + (i + 1) + ") div").text(answer_letters[i - startpos[1]]).css("color", "initial");
    }
    else if (direction == "vertical") {
        $("#" + puzzleId + " tr:nth-child(" + (j + 1) + ") td:nth-child(" + (i + 1) + ") div").text(answer_letters[j - startpos[1]]).css("color", "initial");
    }
}